## wiredpanda 3.0.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12 FATAL_ERROR)

project(WiredPanda
    VERSION 1.0
    DESCRIPTION "Logic Port teaching tool"
    LANGUAGES CXX
)

# wiRedPanda version
set(APP_VERSION "3.0")
option(BUILD_TEST "BUILD_TEST" 0)

set(CMAKE_CXX_STANDARD 17)
set(CXX_STANDARD_REQUIRED ON)

set(QT_MIN_VERSION "5.14.0")

set(CMAKE_AUTOMOC ON)
set(AUTOMOC_MOC_OPTIONS -Muri=org.GIBIS-UNIFESP.wiRedPanda)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

if(MSVC)
  set(COMPILE_WARNS /W4 /WX)
else()
  set(COMPILE_WARNS -Wall -Wextra -pedantic)
endif()

add_compile_definitions(
    QT_USE_QSTRINGBUILDER
    QT_NO_CAST_TO_ASCII
    QT_STRICT_ITERATORS
    QT_NO_CAST_FROM_BYTEARRAY
    QT_USE_FAST_OPERATOR_PLUS
)

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED
    Charts
    Core
    Gui
    Multimedia
    PrintSupport
    Widgets
)

set(
    WPANDA_LIBS
    Qt5::Charts
    Qt5::Core
    Qt5::Gui
    Qt5::Multimedia
    Qt5::PrintSupport
    Qt5::Widgets
)

find_package (ECM ${KF5_MIN_VERSION} NO_MODULE)
set (CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(cmake/Git.cmake)
include(cmake/Format.cmake)

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} )
include_directories(./app/element)
include_directories(./app/nodes)
include_directories(./app)

add_subdirectory(app)
if(BUILD_TEST)
    find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED Test )
    add_subdirectory(test)
endif()

=== app/CMakeLists.txt ===

set(
    WPANDA_FILES
    bewaveddolphin.cpp
    clockDialog.cpp
    commands.cpp
    common.cpp
    editor.cpp
    elementeditor.cpp
    elementfactory.cpp
    elementmapping.cpp
    filehelper.cpp
    globalproperties.cpp
    graphicelement.cpp
    graphicsview.cpp
    graphicsviewzoom.cpp
    ic.cpp
    icmanager.cpp
    icmapping.cpp
    icnotfoundexception.cpp
    icprototype.cpp
    icprototypeimpl.cpp
    itemwithid.cpp
    label.cpp
    LengthDialog.cpp
    listitemwidget.cpp
    logicelement.cpp
    mainwindow.cpp
    recentfilescontroller.cpp
    scene.cpp
    scstop.cpp
    serializationfunctions.cpp
    simplewaveform.cpp
    simulationcontroller.cpp
    thememanager.cpp

    arduino/codegenerator.cpp

    nodes/qneconnection.cpp
    nodes/qneport.cpp
)

add_library(wpandacommon ${WPANDA_FILES} )
target_link_libraries( wpandacommon PUBLIC ${WPANDA_LIBS} )
target_compile_definitions(
    wpandacommon
    PUBLIC
        -DCURRENTDIR="${CMAKE_CURRENT_SOURCE_DIR}"
        -DAPP_VERSION="${APP_VERSION}"
)
target_compile_options( wpandacommon PUBLIC ${COMPILE_WARNS} )

add_subdirectory(element)
add_subdirectory(logicelement)

qt5_add_resources(
    WPANDA_RESOURCES
    resources/dolphin/dolphin.qrc
    resources/resources.qrc
    resources/basic/basic.qrc
    resources/input/input.qrc
    resources/output/output.qrc
    resources/toolbar/toolbar.qrc
    resources/memory/dark/memory_dark.qrc
    resources/memory/light/memory_light.qrc
)

set (
    WPANDA_FORMS
    bewaveddolphin.ui
    clockDialog.ui
    LengthDialog.ui
    mainwindow.ui
    elementeditor.ui
    simplewaveform.ui
)

add_executable(
    wpanda
    main.cpp
    ${WPANDA_FORMS}
    ${WPANDA_RESOURCES}
)

target_compile_definitions(
    wpanda
    PUBLIC
    -DAPP_VERSION="${APP_VERSION}"
)
target_compile_options( wpanda PUBLIC ${COMPILE_WARNS} )

target_link_libraries(
    wpanda
PUBLIC
    ${WPANDA_LIBS}
    wpandacommon
    wpandaelements
    wpandalogicelement
)

=== test/CMakeLists.txt ===

set (
    WPANDA_TEST_FILES
    main.cpp
    testcommands.cpp
    testelements.cpp
    testfiles.cpp
    testicons.cpp
    testlogicelements.cpp
    testsimulationcontroller.cpp
    testwaveform.cpp
)

qt5_add_resources(
    WPANDA_RESOURCES
    ../app/resources/dolphin/dolphin.qrc
    ../app/resources/resources.qrc
    ../app/resources/basic/basic.qrc
    ../app/resources/input/input.qrc
    ../app/resources/output/output.qrc
    ../app/resources/toolbar/toolbar.qrc
    ../app/resources/memory/dark/memory_dark.qrc
    ../app/resources/memory/light/memory_light.qrc
)

add_executable(
    wiredtest
    ${WPANDA_TEST_FILES}
    ${WPANDA_RESOURCES}
)

target_link_libraries(
    wiredtest
PUBLIC
    ${WPANDA_LIBS}
    wpandacommon
    wpandaelements
    wpandalogicelement
    Qt5::Test
)

=== app/element/CMakeLists.txt ===

set (
    WPANDA_ELEMENT
    and.cpp
    clock.cpp
    demux.cpp
    dflipflop.cpp
    display.cpp
    display_14.cpp
    dlatch.cpp
    inputbutton.cpp
    inputgnd.cpp
    inputswitch.cpp
    inputvcc.cpp
    jkflipflop.cpp
    jklatch.cpp
    led.cpp
    mux.cpp
    nand.cpp
    node.cpp
    nor.cpp
    not.cpp
    or.cpp
    srflipflop.cpp
    tflipflop.cpp
    xnor.cpp
    xor.cpp
    buzzer.cpp
)
    # tlatch.cpp
add_library(wpandaelements ${WPANDA_ELEMENT} )
target_link_libraries(wpandaelements PUBLIC ${WPANDA_LIBS} )
target_compile_options(wpandaelements PRIVATE ${COMPILE_WARNS} )

=== app/logicelement/CMakeLists.txt ===

set (
    WPANDA_LOGICELEMENT
    logicnode.cpp
    logicinput.cpp
    logicoutput.cpp
    logicand.cpp
    logicor.cpp
    logicnand.cpp
    logicnor.cpp
    logicxor.cpp
    logicxnor.cpp
    logicnot.cpp
    logicjkflipflop.cpp
    logicsrflipflop.cpp
    logictflipflop.cpp
    logicdflipflop.cpp
    logicdlatch.cpp
    logicmux.cpp
    logicdemux.cpp
)

add_library(wpandalogicelement ${WPANDA_LOGICELEMENT} )
target_link_libraries(wpandalogicelement PUBLIC ${WPANDA_LIBS} )
target_compile_options(wpandalogicelement PRIVATE ${COMPILE_WARNS} )

=== debian/changelog ===
wiredpanda (3.0.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 15 Aug 2021 22:44:03 +0100

wiredpanda (3.0.1-1) experimental; urgency=medium

  * New upstream version 3.0.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 31 Jul 2021 23:05:45 +0100

wiredpanda (3.0.0-1) experimental; urgency=medium

  * Initial release (Closes: #985939)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 28 Mar 2021 00:31:06 +0000

=== debian/control ===
Source: wiredpanda
Section: electronics
Priority: optional
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Build-Depends: debhelper-compat (= 13), qtbase5-dev, qt5-qmake,
               qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev
Standards-Version: 4.5.1
Homepage: https://github.com/GIBIS-UNIFESP/wiRedPanda
Vcs-Browser: https://salsa.debian.org/sudip/wiredpanda
Vcs-Git: https://salsa.debian.org/sudip/wiredpanda.git
Rules-Requires-Root: no

Package: wiredpanda
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: logic circuits simulator
 WiRed Panda is designed to help students to learn about logic circuits
 and simulate them in an easy and friendly way.
 .
 The main features of the software are:
    Real time logic simulation;
    User-friendly interface;
    It's intuitive and easy to use;
    Export your work as an image or a PDF.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=qmake

## wiredpanda 4.1.10

=== debian/changelog ===
wiredpanda (4.1.10-1) unstable; urgency=medium

  * New upstream version 4.1.10
    -  Refresh patch.
    - Update copyright.
    - Modify install and tests for Debian.
    - Install missing files.
    - Modify build dependency.
  * Update Standards-Version to 4.6.1.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 29 Oct 2022 00:29:03 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), qtbase5-dev, qt5-qmake,
-               qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev
-Standards-Version: 4.5.1
+               qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev,
+               libqt5svg5-dev, xvfb, xauth
+Standards-Version: 4.6.1.0
 Homepage: https://github.com/GIBIS-UNIFESP/wiRedPanda
 Vcs-Browser: https://salsa.debian.org/sudip/wiredpanda
 Vcs-Git: https://salsa.debian.org/sudip/wiredpanda.git

## wiredpanda 4.1.12

=== debian/changelog ===
wiredpanda (4.1.12-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:31:43 +1100

wiredpanda (4.1.12-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:30:24 +0000

wiredpanda (4.1.12-1) unstable; urgency=medium

  * New upstream version 4.1.12
    - Update copyright.
  * Update Standards Version to 4.6.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 05 Jul 2023 20:54:59 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: wiredpanda
 Section: electronics
 Priority: optional
-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), qtbase5-dev, qt5-qmake,
                qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev,
                libqt5svg5-dev, xvfb, xauth
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/GIBIS-UNIFESP/wiRedPanda
 Vcs-Browser: https://salsa.debian.org/sudip/wiredpanda
 Vcs-Git: https://salsa.debian.org/sudip/wiredpanda.git

## wiredpanda 4.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(wiredpanda VERSION 4.2.1 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

find_package(Qt6 6.2 QUIET COMPONENTS Core Gui PrintSupport Multimedia Widgets Svg Test)
if(Qt6_FOUND)
    set(QT_VERSION_MAJOR 6)
    set(QT_LIBS Qt6::Core Qt6::Gui Qt6::PrintSupport Qt6::Multimedia Qt6::Widgets Qt6::Svg Qt6::Test)
else()
    find_package(Qt5 5.12 REQUIRED COMPONENTS Core Gui PrintSupport Multimedia Widgets Svg Test)
    set(QT_VERSION_MAJOR 5)
    set(QT_LIBS Qt5::Core Qt5::Gui Qt5::PrintSupport Qt5::Multimedia Qt5::Widgets Qt5::Svg Qt5::Test)
endif()

if((QT_VERSION_MAJOR EQUAL 5 AND Qt5_VERSION VERSION_LESS 5.12) OR
   (QT_VERSION_MAJOR EQUAL 6 AND Qt6_VERSION VERSION_LESS 6.2))
    message(FATAL_ERROR "Minimum required Qt version is 5.12 for Qt5 or 6.2 for Qt6.")
endif()

add_compile_definitions(
    APP_VERSION="${PROJECT_VERSION}"
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
    QT_MESSAGELOGCONTEXT
)

if(MSVC)
    add_compile_options(/W4 /external:W0 /permissive-)
else()
    add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_program(MOLD_BIN mold)
if(MOLD_BIN)
    add_link_options("-fuse-ld=mold")
endif()

if(NOT MSVC)
    find_program(CCACHE_BIN ccache)
    if(CCACHE_BIN)
        set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE_BIN})
        set(CMAKE_C_COMPILER_LAUNCHER ${CCACHE_BIN})
    endif()
endif()

if(QT_VERSION_MAJOR EQUAL 5)
    set(CMAKE_OSX_ARCHITECTURES "x86_64")
else()
    set(CMAKE_OSX_ARCHITECTURES "x86_64;arm64")
endif()

include(CMakeSources.cmake)

if(QT_VERSION_MAJOR EQUAL 5)
    qt5_add_resources(RESOURCES_RCC ${RESOURCES})
else()
    qt6_add_resources(RESOURCES_RCC ${RESOURCES})
endif()

include_directories(
    ${CMAKE_BINARY_DIR}
    app
    app/arduino
    app/element
    app/logicelement
    app/nodes
)

# ========= LIB ===================================

add_library(wiredpanda_lib STATIC ${SOURCES} ${HEADERS} ${FORMS})
target_link_libraries(wiredpanda_lib PUBLIC ${QT_LIBS})

if(NOT CCACHE_BIN)
    target_precompile_headers(wiredpanda_lib PRIVATE pch.h)
endif()

find_path(SENTRY_INCLUDE_DIR NAMES sentry.h PATHS thirdparty/sentry/include)

if (SENTRY_INCLUDE_DIR)
    message(STATUS "Sentry found: Enabling HAVE_SENTRY")
    add_definitions(-DHAVE_SENTRY)

    include_directories(${SENTRY_INCLUDE_DIR})
    link_directories(thirdparty/sentry/lib)
    target_link_libraries(wiredpanda_lib PUBLIC sentry)
else()
    message(STATUS "Sentry not found: Disabling HAVE_SENTRY")
endif()

# ========= APP ===================================

add_executable(wiredpanda app/main.cpp ${RESOURCES_RCC})
target_link_libraries(wiredpanda PRIVATE wiredpanda_lib)

if(NOT CCACHE_BIN)
    target_precompile_headers(wiredpanda PRIVATE pch.h)
endif()

if(WIN32)
    set(WINDOWS_APP_NAME "wiRedPanda - Logic Circuit Simulator")
    set(RC_FILE "resources/wpanda.ico")

    set_target_properties(wiredpanda PROPERTIES
        WIN32_EXECUTABLE ON
        RUNTIME_OUTPUT_NAME "${WINDOWS_APP_NAME}"
    )

    if(EXISTS ${RC_FILE})
        target_sources(wiredpanda PRIVATE ${RC_FILE})
    endif()
endif()

# ========= TESTS ===================================

file(GLOB_RECURSE TEST_SOURCES "test/*.cpp")
file(GLOB_RECURSE TEST_HEADERS "test/*.h")

add_executable(test ${TEST_SOURCES} ${TEST_HEADERS} ${RESOURCES_RCC})
target_link_libraries(test PRIVATE wiredpanda_lib)
target_compile_definitions(test PRIVATE CURRENTDIR=${CMAKE_CURRENT_SOURCE_DIR}/test)

if(NOT CCACHE_BIN)
    target_precompile_headers(test PRIVATE pch.h)
endif()

=== debian/changelog ===
wiredpanda (4.2.1-1) unstable; urgency=medium

  * New upstream version 4.2.1
    - Refresh patch.
    - Update copyright.
  * d/control: Update Standards-Version to 4.7.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 04 Apr 2025 23:13:14 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: wiredpanda
 Section: electronics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), qtbase5-dev, qt5-qmake,
                qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev,
                libqt5svg5-dev, xvfb, xauth
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/GIBIS-UNIFESP/wiRedPanda
 Vcs-Browser: https://salsa.debian.org/sudip/wiredpanda
 Vcs-Git: https://salsa.debian.org/sudip/wiredpanda.git

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=qmake

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/wiredpanda/usr/tests

override_dh_auto_test:
	export XDG_RUNTIME_DIR=/tmp/runtime-trace
	xvfb-run -a dh_auto_test

## wiredpanda 4.2.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.16)
-project(wiredpanda VERSION 4.2.1 LANGUAGES CXX)
+project(wiredpanda VERSION 4.2.6 LANGUAGES CXX)
 
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
@@ -91,8 +91,6 @@
     include_directories(${SENTRY_INCLUDE_DIR})
     link_directories(thirdparty/sentry/lib)
     target_link_libraries(wiredpanda_lib PUBLIC sentry)
-else()
-    message(STATUS "Sentry not found: Disabling HAVE_SENTRY")
 endif()
 
 # ========= APP ===================================

=== debian/changelog ===
wiredpanda (4.2.6-1) unstable; urgency=medium

  * New upstream version 4.2.6

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 10 Aug 2025 12:55:38 +0100

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%wiredpanda-$1.tar.gz%" \
   https://github.com/GIBIS-UNIFESP/wiRedPanda/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## wiredpanda 4.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(wiredpanda VERSION 4.3.0 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Enable conforming preprocessor for MSVC to support __VA_OPT__
if(MSVC)
    add_compile_options(/Zc:preprocessor)
    add_compile_options(/MP)  # Enable parallel compilation
endif()

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

if(EMSCRIPTEN)
    find_package(Qt6 6.9 REQUIRED COMPONENTS Core Gui PrintSupport Multimedia Widgets Svg Test)
    set(QT_VERSION_MAJOR 6)
    set(QT_LIBS Qt6::Core Qt6::Gui Qt6::PrintSupport Qt6::Multimedia Qt6::Widgets Qt6::Svg Qt6::Test)
else()
    find_package(Qt6 6.2 QUIET COMPONENTS Core Gui PrintSupport Multimedia Widgets Svg Test)
    if(Qt6_FOUND)
        set(QT_VERSION_MAJOR 6)
        set(QT_LIBS Qt6::Core Qt6::Gui Qt6::PrintSupport Qt6::Multimedia Qt6::Widgets Qt6::Svg Qt6::Test)
    else()
        find_package(Qt5 5.15 REQUIRED COMPONENTS Core Gui PrintSupport Multimedia Widgets Svg Test)
        set(QT_VERSION_MAJOR 5)
        set(QT_LIBS Qt5::Core Qt5::Gui Qt5::PrintSupport Qt5::Multimedia Qt5::Widgets Qt5::Svg Qt5::Test)
    endif()
endif()

if((QT_VERSION_MAJOR EQUAL 5 AND Qt5_VERSION VERSION_LESS 5.15) OR
   (QT_VERSION_MAJOR EQUAL 6 AND Qt6_VERSION VERSION_LESS 6.2))
    message(FATAL_ERROR "Minimum required Qt version is 5.15 for Qt5 or 6.2 for Qt6.")
endif()

add_compile_definitions(
    APP_VERSION="${PROJECT_VERSION}"
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
    QT_MESSAGELOGCONTEXT
)

if(MSVC)
    add_compile_options(/W4 /external:W0 /permissive-)
else()
    add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_program(MOLD_BIN mold)
if(MOLD_BIN)
    add_link_options(-fuse-ld=mold)
endif()

# Coverage support
if(ENABLE_COVERAGE)
    add_compile_options(--coverage)
    add_link_options(--coverage)
    message(STATUS "Coverage enabled")
endif()

# Sanitizer support
if(CMAKE_CXX_COMPILER_ID STREQUAL Clang OR CMAKE_CXX_COMPILER_ID STREQUAL GNU)
    if(ENABLE_MEMORY_SANITIZER)
        if(CMAKE_CXX_COMPILER_ID STREQUAL Clang)
            add_compile_options(-fsanitize=memory -fPIE)
            add_link_options(-fsanitize=memory -fPIE)
            message(STATUS "Memory Sanitizer enabled")
        else()
            message(WARNING "Memory Sanitizer only supported with Clang")
        endif()
    endif()

    if(ENABLE_ADDRESS_SANITIZER)
        add_compile_options(-fsanitize=address)
        add_link_options(-fsanitize=address)
        message(STATUS "Address Sanitizer enabled")
    endif()

    if(ENABLE_THREAD_SANITIZER)
        add_compile_options(-fsanitize=thread)
        add_link_options(-fsanitize=thread)
        message(STATUS "Thread Sanitizer enabled")
    endif()

    if(ENABLE_UB_SANITIZER)
        if(CMAKE_CXX_COMPILER_ID STREQUAL Clang)
            add_compile_options(-fsanitize=undefined,implicit-integer-truncation,implicit-integer-arithmetic-value-change,implicit-conversion,integer,nullability)
            add_link_options(-fsanitize=undefined,implicit-integer-truncation,implicit-integer-arithmetic-value-change,implicit-conversion,integer,nullability)
        else()
            add_compile_options(-fsanitize=undefined)
            add_link_options(-fsanitize=undefined)
        endif()
        message(STATUS "Undefined Behavior Sanitizer enabled")
    endif()
endif()

if(NOT MSVC)
    find_program(CCACHE_BIN ccache)
    if(CCACHE_BIN)
        set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE_BIN})
        set(CMAKE_C_COMPILER_LAUNCHER ${CCACHE_BIN})
    endif()
endif()

if(QT_VERSION_MAJOR EQUAL 5)
    set(CMAKE_OSX_ARCHITECTURES x86_64)
else()
    set(CMAKE_OSX_ARCHITECTURES "x86_64;arm64")
endif()

# WebAssembly specific configuration
if(EMSCRIPTEN)
    # Essential WASM flags
    add_link_options(-sASYNCIFY -Os)

    # Additional optimization flags recommended by Qt docs
    add_compile_options(-Os -flto)
    add_link_options(-flto)

    message(STATUS "WebAssembly build detected - Adding ASYNCIFY and optimization flags")
endif()

include(CMakeSources.cmake)

# Find available translation files
file(GLOB_RECURSE TS_FILES app/resources/translations/wpanda_*.ts)

# Initialize QM_FILES list
set(QM_FILES)

# Create QM files in source directory so QRC can find them
if(QT_VERSION_MAJOR EQUAL 5)
    find_package(Qt5LinguistTools QUIET)
    if(Qt5LinguistTools_FOUND)
        foreach(ts_file ${TS_FILES})
            get_filename_component(qm_file ${ts_file} NAME_WE)
            get_filename_component(ts_dir ${ts_file} DIRECTORY)
            set(qm_path ${ts_dir}/${qm_file}.qm)
            add_custom_command(
                OUTPUT ${qm_path}
                COMMAND ${Qt5_LRELEASE_EXECUTABLE} ${ts_file} -qm ${qm_path}
                DEPENDS ${ts_file}
                COMMENT "Compiling ${qm_file}.qm"
                VERBATIM
            )
            list(APPEND QM_FILES ${qm_path})
        endforeach()
    endif()
    qt5_add_resources(RESOURCES_RCC ${RESOURCES})
else()
    find_package(Qt6LinguistTools QUIET)
    if(Qt6LinguistTools_FOUND)
        foreach(ts_file ${TS_FILES})
            get_filename_component(qm_file ${ts_file} NAME_WE)
            get_filename_component(ts_dir ${ts_file} DIRECTORY)
            set(qm_path ${ts_dir}/${qm_file}.qm)
            add_custom_command(
                OUTPUT ${qm_path}
                COMMAND Qt6::lrelease ${ts_file} -qm ${qm_path}
                DEPENDS ${ts_file}
                COMMENT "Compiling ${qm_file}.qm"
                VERBATIM
            )
            list(APPEND QM_FILES ${qm_path})
        endforeach()
    endif()
    qt6_add_resources(RESOURCES_RCC ${RESOURCES})
endif()

include_directories(
    ${CMAKE_BINARY_DIR}
    app
    app/arduino
    app/element
    app/logicelement
    app/nodes
)

# ========= TRANSLATIONS ===========================

# Find available translation files
file(GLOB_RECURSE TS_FILES app/resources/translations/wpanda_*.ts)

# Custom targets for translation management
if(Qt5LinguistTools_FOUND OR Qt6LinguistTools_FOUND)
    # Custom target to update translation source files
    if(QT_VERSION_MAJOR EQUAL 5)
        add_custom_target(lupdate
            COMMAND Qt5::lupdate -tr-function-alias tr+=PANDACEPTION ${CMAKE_SOURCE_DIR}/app -ts ${TS_FILES}
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            COMMENT "Updating translation source files"
        )
    else()
        add_custom_target(lupdate
            COMMAND Qt6::lupdate -tr-function-alias tr+=PANDACEPTION ${CMAKE_SOURCE_DIR}/app -ts ${TS_FILES}
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            COMMENT "Updating translation source files"
        )
    endif()

    # Custom target to compile translation files
    add_custom_target(lrelease
        DEPENDS ${QM_FILES}
        COMMENT "Compiling translation files"
    )

    # Make sure resources depend on QM files
    add_custom_target(compile_translations ALL DEPENDS ${QM_FILES})
endif()

# CMake script to generate translations.qrc natively
set(QRC_GENERATOR_SCRIPT "${CMAKE_BINARY_DIR}/generate_translations_qrc.cmake")

# Write the QRC generator script
file(WRITE ${QRC_GENERATOR_SCRIPT} "
# CMake script to generate translations.qrc
set(QRC_FILE \"${CMAKE_SOURCE_DIR}/app/resources/translations/translations.qrc\")

# Get list of .qm files in translations directory
file(GLOB QM_FILES \"${CMAKE_SOURCE_DIR}/app/resources/translations/*.qm\")

# Sort the files for consistent output
list(SORT QM_FILES)

# Start QRC content
set(QRC_CONTENT \"<RCC>\\n    <qresource prefix=\\\"/translations\\\">\\n\")

# Add each .qm file
foreach(qm_file \${QM_FILES})
    get_filename_component(qm_name \${qm_file} NAME)
    string(APPEND QRC_CONTENT \"        <file>\${qm_name}</file>\\n\")
endforeach()

# End QRC content
string(APPEND QRC_CONTENT \"    </qresource>\\n</RCC>\\n\")

# Write the QRC file
file(WRITE \${QRC_FILE} \${QRC_CONTENT})

# Report generation
list(LENGTH QM_FILES QM_COUNT)
message(STATUS \"Generated translations.qrc with \${QM_COUNT} files\")
foreach(qm_file \${QM_FILES})
    get_filename_component(qm_name \${qm_file} NAME)
    message(STATUS \"  - \${qm_name}\")
endforeach()
")

# Custom target to regenerate translations.qrc using native CMake
add_custom_target(generate_translations_qrc
    COMMAND ${CMAKE_COMMAND} -P ${QRC_GENERATOR_SCRIPT}
    COMMENT "Generating translations.qrc with CMake"
    DEPENDS lrelease
)

# Print translation information
list(LENGTH TS_FILES TS_FILES_COUNT)
message(STATUS "Found ${TS_FILES_COUNT} translation files:")
foreach(ts_file ${TS_FILES})
    get_filename_component(lang ${ts_file} NAME_WE)
    string(REPLACE "wpanda_" "" lang ${lang})
    message(STATUS "  - ${lang}")
endforeach()

# ========= LIB ===================================

add_library(wiredpanda_lib STATIC ${SOURCES} ${HEADERS} ${FORMS})
target_link_libraries(wiredpanda_lib PUBLIC ${QT_LIBS})

if(NOT CCACHE_BIN)
    target_precompile_headers(wiredpanda_lib PRIVATE pch.h)
endif()

find_path(SENTRY_INCLUDE_DIR NAMES sentry.h PATHS thirdparty/sentry/include)

if (SENTRY_INCLUDE_DIR)
    message(STATUS "Sentry found: Enabling HAVE_SENTRY")
    add_definitions(-DHAVE_SENTRY)

    include_directories(${SENTRY_INCLUDE_DIR})
    link_directories(thirdparty/sentry/lib)
    target_link_libraries(wiredpanda_lib PUBLIC sentry)
endif()

# ========= APP ===================================

# Use qt_add_executable for WASM builds as recommended by Qt docs
if(EMSCRIPTEN)
    qt_add_executable(wiredpanda app/main.cpp ${RESOURCES_RCC})
else()
    add_executable(wiredpanda app/main.cpp ${RESOURCES_RCC})
endif()
target_link_libraries(wiredpanda PRIVATE wiredpanda_lib)

# Run windeployqt on Windows to copy Qt dependencies
if(WIN32)
    find_program(WINDEPLOYQT_EXECUTABLE windeployqt HINTS ${Qt${QT_VERSION_MAJOR}_DIR}/../../../bin)
    
    if(WINDEPLOYQT_EXECUTABLE)
        add_custom_command(TARGET wiredpanda POST_BUILD
            COMMAND ${WINDEPLOYQT_EXECUTABLE} --verbose 2 --no-translations --no-system-d3d-compiler --no-opengl-sw --no-compiler-runtime $<TARGET_FILE:wiredpanda>
            COMMENT "Deploying Qt libraries with windeployqt"
            VERBATIM
        )
    else()
        message(WARNING "windeployqt not found - Qt libraries will not be automatically deployed")
    endif()
endif()

# Ensure translations are compiled before building the main executable
if(Qt5LinguistTools_FOUND OR Qt6LinguistTools_FOUND)
    add_dependencies(wiredpanda lrelease)
endif()

if(NOT CCACHE_BIN)
    target_precompile_headers(wiredpanda REUSE_FROM wiredpanda_lib)
endif()

if(WIN32)
    set(WINDOWS_APP_NAME "wiRedPanda - Logic Circuit Simulator")
    set(RC_FILE resources/wpanda.ico)

    set_target_properties(wiredpanda PROPERTIES
        WIN32_EXECUTABLE ON
        RUNTIME_OUTPUT_NAME wiredpanda
        # Enhanced Windows metadata
        VERSION "${PROJECT_VERSION}"
        DESCRIPTION "wiRedPanda - Logic Circuit Simulator"
        COMPANY_NAME GIBIS-UNIFESP
        FILE_DESCRIPTION "wiRedPanda - Logic Circuit Simulator"
        LEGAL_COPYRIGHT "GIBIS-UNIFESP and the wiRedPanda contributors"
        ORIGINAL_FILENAME wiredpanda.exe
        PRODUCT_NAME "wiRedPanda - Logic Circuit Simulator"
    )

    if(EXISTS ${RC_FILE})
        target_sources(wiredpanda PRIVATE ${RC_FILE})
    endif()
endif()

# ========= TESTS ===================================

file(GLOB_RECURSE TEST_SOURCES test/*.cpp)
file(GLOB_RECURSE TEST_HEADERS test/*.h)

add_executable(wiredpanda-test ${TEST_SOURCES} ${TEST_HEADERS} ${RESOURCES_RCC})
target_link_libraries(wiredpanda-test PRIVATE wiredpanda_lib)

# Ensure translations are compiled before building the test executable
if(Qt5LinguistTools_FOUND OR Qt6LinguistTools_FOUND)
    add_dependencies(wiredpanda-test lrelease)
endif()
target_compile_definitions(wiredpanda-test PRIVATE CURRENTDIR=${CMAKE_CURRENT_SOURCE_DIR}/test)

if(NOT CCACHE_BIN)
    target_precompile_headers(wiredpanda-test PRIVATE pch.h)
endif()

=== debian/changelog ===
wiredpanda (4.3.0-1) unstable; urgency=medium

  * New upstream version 4.3.0
    - Update builds to use cmake.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 12 Dec 2025 13:53:08 +0000

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: electronics
 Priority: optional
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
-Build-Depends: debhelper-compat (= 13), qtbase5-dev, qt5-qmake,
+Build-Depends: debhelper-compat (= 13), qtbase5-dev,
                qtbase5-dev-tools, libqt5charts5-dev, qtmultimedia5-dev,
-               libqt5svg5-dev, xvfb, xauth
+               libqt5svg5-dev, xvfb, xauth, cmake
 Standards-Version: 4.7.2
 Homepage: https://github.com/GIBIS-UNIFESP/wiRedPanda
 Vcs-Browser: https://salsa.debian.org/sudip/wiredpanda

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddirectory=builddir

override_dh_auto_test:
	export XDG_RUNTIME_DIR=/tmp/runtime-trace
	xvfb-run -a dh_auto_test
